//********************************************************************************
// txt1 : fiches de physique
//********************************************************************************

#define USE_TI89              // Compile pour la TI-89
//#define USE_TI92PLUS          // Compile pour la TI-92 Plus
//#define USE_V200              // Compile pour la V200
#define OPTIMIZE_ROM_CALLS    // Utilise les optimisations d'appel de fonctions dans la ROM
#define SAVE_SCREEN           // Sauvegarde l'cran et le restaure  la sortie

#include <tigcclib.h>         // Inclusion de tous les en-ttes de TIGCC


// structure reprsentant une page (en gnral l'essentiel d'un chapitre)
struct page
{
	const char* titre;    // le titre cu chapitre affich en gros en haut
	const char* txt[11];  // les lignes du chaptitre (11 lignes de 26 car max chacune)
	BOOL chapter;         // ce chapitre est-il le premier d'une grande partie ?
}pages[20];


int i,j;          // compteurs  porte globale utiliss couramment
short maxPage = 0;  // dernire page accessible
short page = 0;     // numro de la page affiche

char buff[50];    // buffer utilis pour formater des chanes de caractres  afficher

//--------------------------------------------------------------------------------
// Affiche un menu de slection de chapitre
//--------------------------------------------------------------------------------
void PopupMenu()
{
	short res = 0;
	ClrScr();
	HANDLE handle = PopupNew ("Chapitre", 100);
  for(i = 0; i <= maxPage; i++)
  {
 		buff[0] = '\0';

 		if(pages[i].chapter)strcat(buff, "<");
 		strcat(buff, pages[i].titre);
 		if(pages[i].chapter)strcat(buff, ">");

 		PopupAddText (handle, -1, buff, i+1);
  }

	res = PopupDo(handle, CENTER, CENTER, page+1);

	if(res == 0)exit(0);

	page = res - 1;
}
//--------------------------------------------------------------------------------
// Fonction principale du programme, commence par charger les chapitres, puis
// rentre dans la boucle d'affichage (avec attente du clavier)
//--------------------------------------------------------------------------------
void _main(void)
{
	page = 0;

	// charge le numro de la page en cours
	FILE* file = fopen ("txt1s", "r");
	if(file != NULL)
	{
		page = fgetc (file);
		fclose (file);
	}

  // initialisation
  for(i = 0; i <= maxPage; i++)
  	pages[i].chapter = FALSE;

  pages[0].chapter = TRUE;
  pages[0].titre =  "Ondes mca progress.";
  //                "--------------------"
  //                "---------------------------"
  pages[0].txt[0]  = "Transversale(perpendic.)";
  pages[0].txt[1]  = "Longitudinale(parallle)";
  pages[0].txt[2]  = "Milieu unidirectionnel, ";
  pages[0].txt[3]  = "deux ou trois dimensions";
  pages[0].txt[4]  = "Une onde se propage sans";
  pages[0].txt[5]  = "transport de matire mais";
  pages[0].txt[6]  = "avec transfert d'nergie";
  pages[0].txt[7]  = "Clrit caract. du milieu";
  pages[0].txt[8]  = "";
  pages[0].txt[9]  = "clrit: v = d/t";
  pages[0].txt[10] = "retard: ' = MM'/v";


  pages[1].titre =  "Ondes priodiques";
  //                "--------------------"
  //                "---------------------------"
  pages[1].txt[0]  = "f = 1/T";
  pages[1].txt[1]  = "T : priodicit temporelle";
  pages[1].txt[2]  = " : priodicit spatiale";
  pages[1].txt[3]  = " spare deux points qui";
  pages[1].txt[4]  = "vibrent en phase";
  pages[1].txt[5]  = " = vT = v/f";
  pages[1].txt[6]  = "Milieu dispersif lorsque";
  pages[1].txt[7]  = "clrit dpend de freq.";
  pages[1].txt[8]  = "";
  pages[1].txt[9]  = "onde diaphragme: fente>>";
  pages[1].txt[10] = "onde diffracte: fente  ";

  pages[2].titre =  "Lumire comme onde";
  //                "--------------------"
  //                "---------------------------"
  pages[2].txt[0]  = "diffraction->nature ondul.";
  pages[2].txt[1]  = "vide: c = 3,008 m/s";
  pages[2].txt[2]  = " = cT = c/ (: frq.)";
  pages[2].txt[3]  = "lum visible: 400  800 nm";
  pages[2].txt[4]  = "ondes lumineuses:~=100THz";
  pages[2].txt[5]  = "lum. monochr.:  dtermin";
  pages[2].txt[6]  = "(rad) = /a(a:larg.fente)";
  pages[2].txt[7]  = "indice de milieu: n = c/v";
  pages[2].txt[8]  = "vitesse du son: 340 m/s";
  pages[2].txt[9]  = "loi de Descartes:";
  pages[2].txt[10] = "n1*sin(i1) = n2*sin(i2)";


  pages[3].chapter = TRUE;
  pages[3].titre =  "La radioactivit";
  //                "--------------------"
  //                "---------------------------"
  pages[3].txt[0]  = "symbole d'un noyau: [A;Z]X";
  pages[3].txt[1]  = "A: nb nuclons, Z: nb prot";
  pages[3].txt[2]  = "valle de stabilit:N=f(Z)";
  pages[3].txt[3]  = "loi Soddy:conservation A&Z";
  pages[3].txt[4]  = "Radioactivit = raction";
  pages[3].txt[5]  = "nuclaire spontane et";
  pages[3].txt[6]  = "invitable";
  pages[3].txt[7]  = ": mission [4;2]He";
  pages[3].txt[8]  = "-: mission [0;-1]e";
  pages[3].txt[9]  = "+: mission [0;+1]e";
  pages[3].txt[10] = "mission de : Y* -> Y + ";

  pages[4].titre =  "Dcroissance radio.";
  //                "--------------------"
  //                "---------------------------"
  pages[4].txt[0]  = "nombre moyen de dsintgr.";
  pages[4].txt[1]  = "- N =  * N * t";
  pages[4].txt[2]  = "N:nb noyaux";
  pages[4].txt[3]  = "N = N0 * (-t)";
  pages[4].txt[4]  = " est la const.radioactive";
  pages[4].txt[5]  = "Demi-vie: t(1/2) = ln2 / ";
  pages[4].txt[6]  = "Activit: nb moy.dsint./s";
  pages[4].txt[7]  = "A(Bq)= -N/t en Becquerel";
  pages[4].txt[8]  = "A = ln2 / t(1/2) * N";
  pages[4].txt[9]  = "datation:";
  pages[4].txt[10] = "t = -1/ * ln(N/N0)";

  pages[5].titre =  "Masse-nergie";
  //                "--------------------"
  //                "---------------------------"
  pages[5].txt[0]  = "E(J) = m(kg) * c";
  pages[5].txt[1]  = "1eV=1,6-19J:lectron volt";
  pages[5].txt[2]  = "Dfaut de masse:";
  pages[5].txt[3]  = "|m| = Z*mp+(A-Z)mn-mX > 0";
  pages[5].txt[4]  = "El = |m| * c";
  pages[5].txt[5]  = "Noyaux stables = El grand";
  pages[5].txt[6]  = "Fission: pour A > 200";
  pages[5].txt[7]  = "Bilan nergtique d'une";
  pages[5].txt[8]  = "raction nuclaire:";
  pages[5].txt[9]  = "(m = variation de masse)";
  pages[5].txt[10] = "Ec = -m * c";

  pages[6].chapter = TRUE;
  pages[6].titre =  "Diple RC";
  //                "--------------------"
  //                "---------------------------"
  pages[6].txt[0]  = "i = q/t ; q(C)";
  pages[6].txt[1]  = "q = C * u ; q(C),C(F),u(V)";
  pages[6].txt[2]  = "";
  pages[6].txt[3]  = "quation diffrentielle:";
  pages[6].txt[4]  = "u + RC * u/t = E";
  pages[6].txt[5]  = "Un diple RC s'oppose aux";
  pages[6].txt[6]  = "variations de la tension";
  pages[6].txt[7]  = "Constante de temps:  = RC";
  pages[6].txt[8]  = "";
  pages[6].txt[9]  = "Energie emmagasine:";
  pages[6].txt[10] = "Ec = 1/2 * C * u";


  pages[7].titre =  "Diple RL";
  //                "--------------------"
  //                "---------------------------"
  pages[7].txt[0]  = "Relation tension-intensit";
  pages[7].txt[1]  = "u = r * i + L * i/t";
  pages[7].txt[2]  = "Bobine s'oppose aux vars.";
  pages[7].txt[3]  = "de l'intensit du courant";
  pages[7].txt[4]  = "";
  pages[7].txt[5]  = "qu. diff. de l'intensit:";
  pages[7].txt[6]  = "i + L/R * i/t = E/R";
  pages[7].txt[7]  = "";
  pages[7].txt[8]  = " = L/R [cste de temps(s)]";
  pages[7].txt[9]  = "Energie emmagasine:";
  pages[7].txt[10] = "El = 1/2 * L * i";


  pages[8].titre =  "Oscillations RLC";
  //                "--------------------"
  //                "---------------------------"
  pages[8].txt[0]  = "Rgime pseudo-priodique,";
  pages[8].txt[1]  = "priodique ou apriodique";
  pages[8].txt[2]  = "Amortissement ngligeable:";
  pages[8].txt[3]  = "u/t + 1/LC * u = 0";
  pages[8].txt[4]  = "Equation horaire de i:";
  pages[8].txt[5]  = "i = -Im * sin(0*t + )";
  pages[8].txt[6]  = "0: pulsation propre circ.";
  pages[8].txt[7]  = "Priode propre:";
  pages[8].txt[8]  = "T0 = 2/0 = 2(LC)";
  pages[8].txt[9]  = "Um : amplitude tension";
  pages[8].txt[10] = " : phase  t=0";


  pages[9].chapter = TRUE;
  pages[9].titre =  "Mecanique de Newton";
  //                "--------------------"
  //                "---------------------------"
  pages[9].txt[0]  = "syst, rfrentiel, F_ext";
  pages[9].txt[1]  = "";
  pages[9].txt[2]  = "1:Fext_=0_<=>v_[G]_=cste_";
  pages[9].txt[3]  = "2:F_[A/B] = - F_[B/A]";
  pages[9].txt[4]  = "3:Fext_ = m * a_[G]";
  pages[9].txt[5]  = "";
  pages[9].txt[6]  = "OM_ = x*i_ + y*j_ + z*k_";
  pages[9].txt[7]  = "";
  pages[9].txt[8]  = "v_[G] = lim(l/t, t, 0)";
  pages[9].txt[9]  = "a_[G] = v_[G]/t";
  pages[9].txt[10] = "";


  pages[10].titre =  "Chute verticale";
  //                "--------------------"
  //                "---------------------------"
  pages[10].txt[0]  = "Rgime initial,permanent";
  pages[10].txt[1]  = "P_ = m * g_";
  pages[10].txt[2]  = "Pousse d'Archimde:";
  pages[10].txt[3]  = "F = ' * V' * g";
  pages[10].txt[4]  = "V': V immerg du solide";
  pages[10].txt[5]  = "': m volumique du fluide";
  pages[10].txt[6]  = "Equ.diff. du mouvement si";
  pages[10].txt[7]  = "f_ = k * v_ :";
  pages[10].txt[8]  = "v[x]/t = a * v[x] + b";
  pages[10].txt[9]  = "Mth. d'Euler(cond. init.)";
  pages[10].txt[10] = "Chute libre: v[x]/t = g";


  pages[11].titre = "Mvt. de projectiles";
  //                "--------------------"
  //                "---------------------------"
  pages[11].txt[0]  = "v_[x/t ; y/t ; z/t]";
  pages[11].txt[1]  = "a_[vx/t;vy/t;vz/t]";
  pages[11].txt[2]  = "";
  pages[11].txt[3]  = "Fext_ = P_";
  pages[11].txt[4]  = "(i_,v0_) =  (vit. init.)";
  pages[11].txt[5]  = "a_[G] = g_";
  pages[11].txt[6]  = "Equ. horaires. param.:";
  pages[11].txt[7]  = "y(t)= (v0 * cos) * t";
  pages[11].txt[8]  = "z(t)= -1/2gt + (v0sin)t";
  pages[11].txt[9]  = "Trajectoire parabolique:";
  pages[11].txt[10] = "z = Ay + By";


  pages[12].titre = "Satellites&plantes1";
  //                "--------------------"
  //                "---------------------------"
  pages[12].txt[0]  = "Rf hlio-/gocentrique";
  pages[12].txt[1]  = "Lois de Kepler:";
  pages[12].txt[2]  = "1)centre soleil = foyer";
  pages[12].txt[3]  = "de l'ellipse de la traj.";
  pages[12].txt[4]  = "d'une plante (rf hlio)";
  pages[12].txt[5]  = "2)SP_(sol-plante) balaie";
  pages[12].txt[6]  = "des aires gales pendant";
  pages[12].txt[7]  = "des dures gales";
  pages[12].txt[8]  = "3)T / a = cste";
  pages[12].txt[9]  = "T: priode de rvolution";
  pages[12].txt[10] = "a: demi grand axe ellipse";


  pages[13].titre = "Satellites&plantes2";
  //                "--------------------"
  //                "---------------------------"
  pages[13].txt[0]  = "Vecteur acclrat. radial";
  pages[13].txt[1]  = "(dirig vers le centre)";
  pages[13].txt[2]  = "Mouvement circ. uniforme:";
  pages[13].txt[3]  = "a = v / r";
  pages[13].txt[4]  = "Forces d'interact.grav. :";
  pages[13].txt[5]  = "F= -G * (mA*mB)/r u_[AB]";
  pages[13].txt[6]  = "Vit. centre d'une plante";
  pages[13].txt[7]  = "v = (G * M[s] / r)";
  pages[13].txt[8]  = "Priode de rvolution:";
  pages[13].txt[9]  = "v = 2r/v = 2(r/GM[s])";
  pages[13].txt[10] = "Gostationnaire: T=23h56m";


  pages[14].titre =  "Systmes oscillants";
  //                "--------------------"
  //                "---------------------------"
  pages[14].txt[0]  = "pendule pesant-lastique";
  pages[14].txt[1]  = "abscisse angulaire: (t)";
  pages[14].txt[2]  = "amplitude: m";
  pages[14].txt[3]  = "";
  pages[14].txt[4]  = "T0  f(m) (isochronisme";
  pages[14].txt[5]  = "des petites oscillations)";
  pages[14].txt[6]  = "";
  pages[14].txt[7]  = "mouvement priodique,";
  pages[14].txt[8]  = "pseudo-T-ique, apriodique";
  pages[14].txt[9]  = "";
  pages[14].txt[10] = "T0 = 2(l/g)";


  pages[15].titre =  "Solide-Ressort";
  //                "--------------------"
  //                "---------------------------"
  pages[15].txt[0]  = "F_ = -k*x*i_ ";
  pages[15].txt[1]  = "";
  pages[15].txt[2]  = "x:allongement algbrique";
  pages[15].txt[3]  = "k:raideur en N/m";
  pages[15].txt[4]  = "";
  pages[15].txt[5]  = "q diffrentielle:";
  pages[15].txt[6]  = "x/t + (k/m)x = 0";
  pages[15].txt[7]  = "";
  pages[15].txt[8]  = "";
  pages[15].txt[9]  = "priode propre:";
  pages[15].txt[10] = "T0 = 2(m/k)";


  pages[16].titre =  "Rsonance";
  //                "--------------------"
  //                "---------------------------"
  pages[16].txt[0]  = "syst.oscillant: rsonateur";
  pages[16].txt[1]  = "excitateur (freq f)";
  pages[16].txt[2]  = "";
  pages[16].txt[3]  = "oscillations forces";
  pages[16].txt[4]  = "courbe de rponse f(freq)";
  pages[16].txt[5]  = "";
  pages[16].txt[6]  = "rsonance aige,floue";
  pages[16].txt[7]  = "";
  pages[16].txt[8]  = "rsonance importante si";
  pages[16].txt[9]  = "amortissement faible";
  pages[16].txt[10] = "et f proche de f0";


  pages[17].titre =  "";
  //                "--------------------"
  //                "---------------------------"
  pages[17].txt[0]  = "";
  pages[17].txt[1]  = "";
  pages[17].txt[2]  = "";
  pages[17].txt[3]  = "";
  pages[17].txt[4]  = "";
  pages[17].txt[5]  = "";
  pages[17].txt[6]  = "";
  pages[17].txt[7]  = "";
  pages[17].txt[8]  = "";
  pages[17].txt[9]  = "";
  pages[17].txt[10] = "";


  pages[18].titre =  "";
  //                "--------------------"
  //                "---------------------------"
  pages[18].txt[0]  = "";
  pages[18].txt[1]  = "";
  pages[18].txt[2]  = "";
  pages[18].txt[3]  = "";
  pages[18].txt[4]  = "";
  pages[18].txt[5]  = "";
  pages[18].txt[6]  = "";
  pages[18].txt[7]  = "";
  pages[18].txt[8]  = "";
  pages[18].txt[9]  = "";
  pages[18].txt[10] = "";


  pages[19].titre =  "";
  //                "--------------------"
  //                "---------------------------"
  pages[19].txt[0]  = "";
  pages[19].txt[1]  = "";
  pages[19].txt[2]  = "";
  pages[19].txt[3]  = "";
  pages[19].txt[4]  = "";
  pages[19].txt[5]  = "";
  pages[19].txt[6]  = "";
  pages[19].txt[7]  = "";
  pages[19].txt[8]  = "";
  pages[19].txt[9]  = "";
  pages[19].txt[10] = "";

	maxPage = 16;

  // vrifications
  for(i = 0; i <= maxPage;i++)
  {
  	if(strlen(pages[i].titre) > 20)
  	{
  		sprintf(buff, "Le titre %d est trop long (20 car max)", i);
  		DlgMessage("Attention", buff, BT_OK, BT_NONE);
  		exit(0);
  	}

  	for(j = 0; j < 11; j++)
  	{
  		if(strlen(pages[i].txt[j]) > 26)
  		{
  			sprintf(buff, "La ligne %d du %d est trop long (26 car max)", j,i);
  			DlgMessage("Attention", buff, BT_OK, BT_NONE);
  			exit(0);
  		}
  	}
  }



	//PopupMenu();
	while(1)
	{
		ClrScr();

		// affiche le titre (20 car) en gros et centr horizontalement
		FontSetSys(F_8x10);
		DrawStr (80 - strlen(pages[page].titre)*8/2, 0, pages[page].titre, A_NORMAL);

		// affiche le texte
		FontSetSys(F_6x8);
		int y;
		for(y = 0; y < 11; y++)
			DrawStr(2, 12+y*8, pages[page].txt[y], A_NORMAL);

		// entre en mode conomisation des batteries (low power)
		idle();

		// attend une frappe sur une touche
	  short car = ngetchx ();

  	if(car == KEY_ESC)break;

	  if(car == KEY_LEFT)
  	{
  		if(page>0)page--;
	  	else page = maxPage;
  	}

	  if(car == KEY_RIGHT)
  	{
  		if(page<maxPage)page++;
	  	else page = 0;
  	}

	  if(car == KEY_UP)
  	{
  		do
  		{
  			page--;
	  		if(page < 0)page = maxPage;
  		}
  		while(!pages[page].chapter);
	  }
  	if(car == KEY_DOWN)
	  {
  		do
  		{
  			page++;
  			if(page > maxPage)page = 0;
	  	}
  		while(!pages[page].chapter);
	  }

		if(car == KEY_CLEAR)
		{
			ClrScr();
			off();
			break;
		}

		if(car == KEY_ON)
		{
			ClrScr();
			off();
		}

	  if(car == KEY_APPS)
  	{
  		PopupMenu();
	  }
	}
	
	// sauvegarde le numro de la page en cours
	file = fopen ("txt1s", "w");
	if(file != NULL)
	{
		fputc ((short)page, file);
		fclose (file);
	}
}





