//********************************************************************************
// txt3 : fiches de mca
//********************************************************************************

#define USE_TI89              // Compile pour la TI-89
//#define USE_TI92PLUS          // Compile pour la TI-92 Plus
//#define USE_V200              // Compile pour la V200
#define OPTIMIZE_ROM_CALLS    // Utilise les optimisations d'appel de fonctions dans la ROM
#define SAVE_SCREEN           // Sauvegarde l'cran et le restaure  la sortie

#include <tigcclib.h>         // Inclusion de tous les en-ttes de TIGCC


// structure reprsentant une page (en gnral l'essentiel d'un chapitre)
struct page
{
	const char* titre;    // le titre cu chapitre affich en gros en haut
	const char* txt[11];  // les lignes du chaptitre (11 lignes de 26 car max chacune)
	BOOL chapter;         // ce chapitre est-il le premier d'une grande partie ?
}pages[11];


int i,j;          // compteurs  porte globale utiliss couramment
int maxPage = 0;  // dernire page accessible
int page = 0;     // numro de la page affiche

char buff[50];    // buffer utilis pour formater des chanes de caractres  afficher

//--------------------------------------------------------------------------------
// Affiche un menu de slection de chapitre
//--------------------------------------------------------------------------------
void PopupMenu()
{
	short res = 0;
	ClrScr();
	HANDLE handle = PopupNew ("Chapitre", 100);
  for(i = 0; i <= maxPage; i++)
  {
 		buff[0] = '\0';

 		if(pages[i].chapter)strcat(buff, "<");
 		strcat(buff, pages[i].titre);
 		if(pages[i].chapter)strcat(buff, ">");

 		PopupAddText (handle, -1, buff, i+1);
  }

	res = PopupDo(handle, CENTER, CENTER, page+1);

	if(res == 0)exit(0);

	page = res - 1;
}
//--------------------------------------------------------------------------------
// Fonction principale du programme, commence par charger les chapitres, puis
// rentre dans la boucle d'affichage (avec attente du clavier)
//--------------------------------------------------------------------------------
void _main(void)
{
	page = 0;

	// charge le numro de la page en cours
	FILE* file = fopen ("txt3s", "r");
	if(file != NULL)
	{
		page = fgetc (file);
		fclose (file);
	}

  // initialisation
  for(i = 0; i <= maxPage; i++)
  	pages[i].chapter = FALSE;

  pages[0].chapter = TRUE;
  pages[0].titre =  "Vecteurs";
  //                "--------------------"
  //                "---------------------------"
  pages[0].txt[0]  = "coordonnes dans le plan:";
  pages[0].txt[1]  = "V_=[Vcos;Vsin]";
  pages[0].txt[2]  = "coordonnes dans l'espace:";
  pages[0].txt[3]  = "Vcoscos;Vcossin;Vsin";
  pages[0].txt[4]  = "";
  pages[0].txt[5]  = "produit vectoriel:";
  pages[0].txt[6]  = "R=A*B*sin [ = (A_,B_)]";
  pages[0].txt[7]  = "";
  pages[0].txt[8]  = "R_=(YA*ZB-ZA*YB)x_";
  pages[0].txt[9]  = "  +(-XA*ZB+ZA*XB)y_";
  pages[0].txt[10] = "  +(XA*YB-YA*XB)z_";


  pages[1].titre =  "Torseurs";
  //                "--------------------"
  //                "---------------------------"
  pages[1].txt[0]  = "compos d'une rsultante:";
  pages[1].txt[1]  = "R_ = (V_[i], i=1, n)";
  pages[1].txt[2]  = "et d'un moment rsultant";
  pages[1].txt[3]  = "exprim au point choisi B:";
  pages[1].txt[4]  = "M_B= (BA_[i]^V_[i],i=1,n)";
  pages[1].txt[5]  = "";
  pages[1].txt[6]  = "criture d'un torseur en";
  pages[1].txt[7]  = "un autre point:";
  pages[1].txt[8]  = "M_[C] = CB_^R_ + M_[B]";
  pages[1].txt[9]  = "";
  pages[1].txt[10] = "";

  pages[2].titre =  "Liaisons";
  //                "--------------------"
  //                "---------------------------"
  pages[2].txt[0]  = "sphre-plan ou ponctuelle";
  pages[2].txt[1]  = "linaire rectiligne";
  pages[2].txt[2]  = "lin. annulaire ou sph-cyl";
  pages[2].txt[3]  = "appui-plan";
  pages[2].txt[4]  = "sphrique ou rotule";
  pages[2].txt[5]  = "pivot glissant";
  pages[2].txt[6]  = "pivot";
  pages[2].txt[7]  = "glissire";
  pages[2].txt[8]  = "hlicodale";
  pages[2].txt[9]  = "complte";
  pages[2].txt[10] = "";


  pages[3].titre =   "PFS";
  //                 "--------------------"
  //                 "---------------------------"
  pages[3].txt[0]  = "un solide(S) sous l'action";
  pages[3].txt[1]  = "de n forces extrieures";
  pages[3].txt[2]  = "reste en quilibre si:";
  pages[3].txt[3]  = "La somme vectorielle de";
  pages[3].txt[4]  = "toutes les forces ext.";
  pages[3].txt[5]  = "appliques au solide est";
  pages[3].txt[6]  = "nulle et";
  pages[3].txt[7]  = "Le moment rsultant en";
  pages[3].txt[8]  = "n'importe quel point I de";
  pages[3].txt[9]  = "toutes les forces ext.";
  pages[3].txt[10] = "appliques  (S) est nul";

  pages[4].titre =  "Rsolution";
  //                "--------------------"
  //                "---------------------------"
  pages[4].txt[0]  = "Isoler le solide ou";
  pages[4].txt[1]  = "l'ensemble des solides";
  pages[4].txt[2]  = "Faire le bilan des tors.";
  pages[4].txt[3]  = "d'actions mcaniques";
  pages[4].txt[4]  = "si inc>6:isoler d'autres";
  pages[4].txt[5]  = "solides et appliquer le";
  pages[4].txt[6]  = "principe des actions";
  pages[4].txt[7]  = "mutuelles";
  pages[4].txt[8]  = "inc6:exprimer tous les";
  pages[4].txt[9]  = "torseurs au mme point";
  pages[4].txt[10] = "equ.scal.de projection";

  pages[5].titre =  "Rsolution graphique";
  //                 "--------------------"
  //                 "---------------------------"
  pages[5].txt[0]  = "composition des vitesses";
  pages[5].txt[1]  = "VC_[A/R]=VC_[A/B]+VC_[B/R]";
  pages[5].txt[2]  = "homothtie des v. vitesse,";
  pages[5].txt[3]  = "uniquement pour rotation:";
  pages[5].txt[4]  = "VA[S/R] = r";
  pages[5].txt[5]  = "quiprojectivit des v.v.";
  pages[5].txt[6]  = "sur un mme axe";
  pages[5].txt[7]  = "C.I.R.:";
  pages[5].txt[8]  = "Le C.I.R. se situe sur une";
  pages[5].txt[9]  = "perpendiculaire au support";
  pages[5].txt[10] = "de chaque vecteur vitesse";

  pages[6].chapter = TRUE;
  pages[6].titre =   "Roulements";
  //                 "--------------------"
  //                 "---------------------------"
  pages[6].txt[0]  = "arbre tournant/dir. charge";
  pages[6].txt[1]  = "BI serre - BE glissante";
  pages[6].txt[2]  = "moyeu tournant/dir charge";
  pages[6].txt[3]  = "BI glissante - BE serre";
  pages[6].txt[4]  = "";
  pages[6].txt[5]  = "critre:";
  pages[6].txt[6]  = "direction de la charge";
  pages[6].txt[7]  = "";
  pages[6].txt[8]  = "charge radiale / axiale";
  pages[6].txt[9]  = "radiale = perpendiculaire";
  pages[6].txt[10] = " la direction de l'axe";


  pages[7].titre =   "Engrenages";
  //                 "--------------------"
  //                 "---------------------------"
  pages[7].txt[0]  = "N1,N2:freq.rotation (t/mn)";
  pages[7].txt[1]  = "R1,R2:rayons des roues";
  pages[7].txt[2]  = "N2/N1 = R1/R2";
  pages[7].txt[3]  = "profil dveloppante cercle";
  pages[7].txt[4]  = "Z: nombre de dents  p: pas";
  pages[7].txt[5]  = "cercle tte,pied,primitif";
  pages[7].txt[6]  = "d = p/ * Z (p/=m:module)";
  pages[7].txt[7]  = "d = m*Z";
  pages[7].txt[8]  = "entraxe e01-02=m(Z1+Z2)/2";
  pages[7].txt[9]  = "2/1 = -d1/d2 = -Z1/Z2";
  pages[7].txt[10] = "";


  pages[8].titre =   "Relation de Willis";
  //                 "--------------------"
  //                 "---------------------------"
  pages[8].txt[0]  = "e : vitesse d'entre";
  pages[8].txt[1]  = "s : vitesse de sortie";
  pages[8].txt[2]  = "r  : rapport = s/e";
  pages[8].txt[3]  = "";
  pages[8].txt[4]  = "r = (-1)^p * ";
  pages[8].txt[5]  = " des Z des roues menantes";
  pages[8].txt[6]  = "--------------------------";
  pages[8].txt[7]  = "  des Z des roues menes";
  pages[8].txt[8]  = "";
  pages[8].txt[9]  = "";
  pages[8].txt[10] = "";


  pages[9].titre =  "Rsistance des mat.";
  //                "--------------------"
  //                "---------------------------"
  pages[9].txt[0]  = "traction-compression : X";
  pages[9].txt[1]  = "cisaillement         : Z";
  pages[9].txt[2]  = "flexion              : M";
  pages[9].txt[3]  = "torsion              : L";
  pages[9].txt[4]  = "zone lastique, plastique";
  pages[9].txt[5]  = "traction: dformation = l";
  pages[9].txt[6]  = "F/S = E * l/l";
  pages[9].txt[7]  = "E: module d'Young (last.)";
  pages[9].txt[8]  = "N_:rsultante de cohsion";
  pages[9].txt[9]  = "contrainte: =N/S";
  pages[9].txt[10] = "on note  = l/l";


  pages[10].titre = "Rsistance des mat.2";
  //                "--------------------"
  //                "---------------------------"
  pages[10].txt[0]  = "Loi de Hooke:";
  pages[10].txt[1]  = "=E";
  pages[10].txt[2]  = "";
  pages[10].txt[3]  = "N/S = E * l/l";
  pages[10].txt[4]  = "";
  pages[10].txt[5]  = "rsistance pratique last";
  pages[10].txt[6]  = "Rpe = Re/s";
  pages[10].txt[7]  = "s:coeff. de scurit";
  pages[10].txt[8]  = "";
  pages[10].txt[9]  = "FLEXION:";
  pages[10].txt[10] = " = Mf/IGz * y";


	maxPage = 10;

  // vrifications
  for(i = 0; i <= maxPage;i++)
  {
  	if(strlen(pages[i].titre) > 20)
  	{
  		sprintf(buff, "Le titre %d est trop long (20 car max)", i);
  		DlgMessage("Attention", buff, BT_OK, BT_NONE);
  		exit(0);
  	}

  	for(j = 0; j < 11; j++)
  	{
  		if(strlen(pages[i].txt[j]) > 26)
  		{
  			sprintf(buff, "La ligne %d du %d est trop long (26 car max)", j,i);
  			DlgMessage("Attention", buff, BT_OK, BT_NONE);
  			exit(0);
  		}
  	}
  }



	//PopupMenu();
	while(1)
	{
		ClrScr();

		// affiche le titre (20 car) en gros et centr horizontalement
		FontSetSys(F_8x10);
		DrawStr (80 - strlen(pages[page].titre)*8/2, 0, pages[page].titre, A_NORMAL);

		// affiche le texte
		FontSetSys(F_6x8);
		int y;
		for(y = 0; y < 11; y++)
			DrawStr(2, 12+y*8, pages[page].txt[y], A_NORMAL);

		// entre en mode conomisation des batteries (low power)
		idle();

		// attend une frappe sur une touche
	  short car = ngetchx ();

  	if(car == KEY_ESC)break;

	  if(car == KEY_LEFT)
  	{
  		if(page>0)page--;
	  	else page = maxPage;
  	}

	  if(car == KEY_RIGHT)
  	{
  		if(page<maxPage)page++;
	  	else page = 0;
  	}

	  if(car == KEY_UP)
  	{
  		do
  		{
  			page--;
	  		if(page < 0)page = maxPage;
  		}
  		while(!pages[page].chapter);
	  }
  	if(car == KEY_DOWN)
	  {
  		do
  		{
  			page++;
  			if(page > maxPage)page = 0;
	  	}
  		while(!pages[page].chapter);
	  }

		if(car == KEY_CLEAR)
		{
			ClrScr();
			off();
			break;
		}

		if(car == KEY_ON)
		{
			ClrScr();
			off();
		}

	  if(car == KEY_APPS)
  	{
  		PopupMenu();
	  }
	}

	// sauvegarde le numro de la page en cours
	file = fopen ("txt3s", "w");
	if(file != NULL)
	{
		fputc ((short)page, file);
		fclose (file);
	}
}