//********************************************************************************
// txt4 : fiches d'lectronique
//********************************************************************************

#define USE_TI89              // Compile pour la TI-89
//#define USE_TI92PLUS          // Compile pour la TI-92 Plus
//#define USE_V200              // Compile pour la V200
#define OPTIMIZE_ROM_CALLS    // Utilise les optimisations d'appel de fonctions dans la ROM
#define SAVE_SCREEN           // Sauvegarde l'cran et le restaure  la sortie

#include <tigcclib.h>         // Inclusion de tous les en-ttes de TIGCC


// structure reprsentant une page (en gnral l'essentiel d'un chapitre)
struct page
{
	const char* titre;    // le titre cu chapitre affich en gros en haut
	const char* txt[11];  // les lignes du chaptitre (11 lignes de 26 car max chacune)
	BOOL chapter;         // ce chapitre est-il le premier d'une grande partie ?
}pages[20];


int i,j;          // compteurs  porte globale utiliss couramment
int maxPage = 0;  // dernire page accessible
int page = 0;     // numro de la page affiche

char buff[50];    // buffer utilis pour formater des chanes de caractres  afficher

//--------------------------------------------------------------------------------
// Affiche un menu de slection de chapitre
//--------------------------------------------------------------------------------
void PopupMenu()
{
	short res = 0;
	ClrScr();
	HANDLE handle = PopupNew ("Chapitre", 100);
  for(i = 0; i <= maxPage; i++)
  {
 		buff[0] = '\0';

 		if(pages[i].chapter)strcat(buff, "<");
 		strcat(buff, pages[i].titre);
 		if(pages[i].chapter)strcat(buff, ">");

 		PopupAddText (handle, -1, buff, i+1);
  }

	res = PopupDo(handle, CENTER, CENTER, page+1);

	if(res == 0)exit(0);

	page = res - 1;
}
//--------------------------------------------------------------------------------
// Fonction principale du programme, commence par charger les chapitres
//--------------------------------------------------------------------------------
void _main(void)
{
	page = 0;

	// charge le numro de la page en cours
	FILE* file = fopen ("txt4s", "r");
	if(file != NULL)
	{
		page = fgetc (file);
		fclose (file);
	}

  // initialisation
  for(i = 0; i <= maxPage; i++)
  	pages[i].chapter = FALSE;

  pages[0].chapter = TRUE;
  pages[0].titre =  "Bases 1";
  //                "--------------------"
  //                "---------------------------"
  pages[0].txt[0]  = "U reprsente une tension";
  pages[0].txt[1]  = "V reprsente un potentiel";
  pages[0].txt[2]  = "U[AB] = V[A] - V[B]";
  pages[0].txt[3]  = "Convention gnrateur: le";
  pages[0].txt[4]  = "courant et la tension sont";
  pages[0].txt[5]  = "dans le mme sens";
  pages[0].txt[6]  = "Convention rcepteur:";
  pages[0].txt[7]  = "sens contraire";
  pages[0].txt[8]  = "";
  pages[0].txt[9]  = "Diple actif: I=f(U) passe";
  pages[0].txt[10] = "par l'origine";
//

  pages[1].titre =  "Bases 2";
  //                "--------------------"
  //                "---------------------------"
  pages[1].txt[0]  = "Diple passif: I=f(U)";
  pages[1].txt[1]  = "ne passe pas par 0";
  pages[1].txt[2]  = "";
  pages[1].txt[3]  = "";
  pages[1].txt[4]  = "Source de tension idale:";
  pages[1].txt[5]  = "tension indpendante du";
  pages[1].txt[6]  = "courant dbit";
  pages[1].txt[7]  = "";
  pages[1].txt[8]  = "Source de courant idale:";
  pages[1].txt[9]  = "courant indpendant de la";
  pages[1].txt[10] = "tension  ses bornes";

  pages[2].titre =  "Bases 3";
  //                "--------------------"
  //                "---------------------------"
  pages[2].txt[0]  = "loi d'ohm : U = RI";
  pages[2].txt[1]  = "rsistances en srie:";
  pages[2].txt[2]  = "Rq = R1 + R2 + R3";
  pages[2].txt[3]  = "rsistances en parallle:";
  pages[2].txt[4]  = "1/Rq = 1/R1 + 1/R2 + 1/R3";
  pages[2].txt[5]  = "loi des noeuds:";
  pages[2].txt[6]  = "I = I1 + I2 + I3";
  pages[2].txt[7]  = "loi des mailles";
  pages[2].txt[8]  = "U1 + U2 + U3 = 0";
  pages[2].txt[9]  = "Orienter la maille et";
  pages[2].txt[10] = "additionner les tensions";


  pages[3].chapter = TRUE;
  pages[3].titre =  "multimtre analog.";
  //                "--------------------"
  //                "---------------------------"
  pages[3].txt[1]  = "x = (d * Cal) / Pe";

  pages[3].txt[3]  = "x: valeur lue";
  pages[3].txt[4]  = "d: dviation de l'aiguille";
  pages[3].txt[5]  = "Cal:calibre choisi";
  pages[3].txt[6]  = "PE: pleine chelle";

  pages[4].titre =  "GBF";
  //                "--------------------"
  //                "---------------------------"
  pages[4].txt[0]  = "procdure de rglage:";
  pages[4].txt[1]  = "choisir forme du signal";
  pages[4].txt[2]  = "rgler freq. signal";
  pages[4].txt[3]  = "rgler coeff. mult.";
  pages[4].txt[4]  = "rgler avec vernier[0.2,2]";
  pages[4].txt[5]  = "rgler amplitude crte";
  pages[4].txt[6]  = "avec le bouton level";
  pages[4].txt[7]  = "rgler offset( partir 0)";
  pages[4].txt[8]  = "Uoffset = (Umax+Umin) / 2";
  pages[4].txt[9]  = "amplitude crte =";
  pages[4].txt[10] = "Umax - Uoffset";

  pages[5].titre =  "Oscilloscope";
  //                "--------------------"
  //                "---------------------------"
  pages[5].txt[0]  = "Mise sous tension";
  pages[5].txt[1]  = "relcher tous les BP";
  pages[5].txt[2]  = "mettre attnuateurs  0";
  pages[5].txt[3]  = "rgler l'intensit lum.";
  pages[5].txt[4]  = "rgler la nettet(focus)";
  pages[5].txt[5]  = "choisir un ou deux canaux";
  pages[5].txt[6]  = "rglage du zro:";
  pages[5].txt[7]  = "- commutateur sur ground";
  pages[5].txt[8]  = "- aligner la trace";
  pages[5].txt[9]  = "- commutateur sur DC";
  pages[5].txt[10] = "prt";


  pages[6].titre =  "Oscilloscope:graphe";
  //                "--------------------"
  //                "---------------------------"
  pages[6].txt[0]  = "indiquer sur le graphique:";
  pages[6].txt[1]  = "reprer l'origine (0)";
  pages[6].txt[2]  = "reprer les axes t,U,unit";
  pages[6].txt[3]  = "graduer les axes";
  pages[6].txt[4]  = "indiquer Umax, Umin";
  pages[6].txt[5]  = "priode T du signal (ms)";
  pages[6].txt[6]  = "frquence (Hz)";
  pages[6].txt[7]  = "indiquer Uoffset(milieu)";
  pages[6].txt[8]  = "";
  pages[6].txt[9]  = "";
  pages[6].txt[10] = "";


  pages[7].chapter = TRUE;
  pages[7].titre =  "Transistor bipolaire";
  //                "--------------------"
  //                "---------------------------"
  pages[7].txt[0]  = "transistor NPN:";
  pages[7].txt[1]  = "Ic: C->E          Ib: B->E";
  pages[7].txt[2]  = "";
  pages[7].txt[3]  = "transistor PNP:";
  pages[7].txt[4]  = "Ic: E->C          Ib: E->B";
  pages[7].txt[5]  = "";
  pages[7].txt[6]  = "";
  pages[7].txt[7]  = "Ib=0 => Ic=0 : bloqu";
  pages[7].txt[8]  = "IbIbsat => Ic=max: satur";
  pages[7].txt[9]  = "";
  pages[7].txt[10] = "";

  pages[8].titre =  "Condensateurs";
  //                "--------------------"
  //                "---------------------------"
  pages[8].txt[0]  = "mise en srie:";
  pages[8].txt[1]  = "1/Cq = 1/C1 + 1/C2 + ";
  pages[8].txt[2]  = "mise en parallle:";
  pages[8].txt[3]  = "Cq = C1 + C2 + ";
  pages[8].txt[4]  = "Charge et dcharge ";
  pages[8].txt[5]  = "travers une rsistance:";
  pages[8].txt[6]  = "Vc(t)=(Vi-Vf)(-t/) + Vf";
  pages[8].txt[7]  = " = RC(s)";
  pages[8].txt[8]  = "";
  pages[8].txt[9]  = "pour trouver t : ln()";
  pages[8].txt[10] = "";


  pages[9].titre =  "ALI (ampli op)";
  //                "--------------------"
  //                "---------------------------"
  pages[9].txt[0]  = "amplification: Vs=K*Ve";
  pages[9].txt[1]  = " = Ve+ - Ve-";
  pages[9].txt[2]  = "sans rtroaction:";
  pages[9].txt[3]  = "Vs = Ad(Ve+ - Ve-)";
  pages[9].txt[4]  = "Alimentation bitension ou";
  pages[9].txt[5]  = "monotension (+Vcc et -Vcc)";
  pages[9].txt[6]  = "Ve+: entre non inverseuse";
  pages[9].txt[7]  = "Ve-: entre inverseuse";
  pages[9].txt[8]  = "en thorie:  Ad = ";
  pages[9].txt[9]  = "en pratique: Ad = 10^5";
  pages[9].txt[10] = "";


  pages[10].titre =  "ALI (suite)";
  //                "--------------------"
  //                "---------------------------"
  pages[10].txt[0]  = "rgimes de fonctionnement";
  pages[10].txt[1]  = "pas de rtroaction:";
  pages[10].txt[2]  = "rgime non linaire";
  pages[10].txt[3]  = "Vs = Ad(Ve+ - Ve-)";
  pages[10].txt[4]  = "rtroaction sur Ve+ :";
  pages[10].txt[5]  = "rgime non linaire";
  pages[10].txt[6]  = "Vs = Ad(Ve+ - Ve-)";
  pages[10].txt[7]  = "rtroaction sur Ve- :";
  pages[10].txt[8]  = "Vs = K * Ve";
  pages[10].txt[9]  = "amplification contrle";
  pages[10].txt[10] = "-> ampli. non inverseur";


  pages[11].chapter = TRUE;
  pages[11].titre = "Rseau monophase";
  //                "--------------------"
  //                "---------------------------"
  pages[11].txt[0]  = "u(t)=U(2)sin(t)";
  pages[11].txt[1]  = "U:valeur efficace de u(t)";
  pages[11].txt[2]  = ": pulsation angulaire";
  pages[11].txt[3]  = " = 2f (rad/s)";
  pages[11].txt[4]  = "";
  pages[11].txt[5]  = "i(t)=I(2)sin(t-)";
  pages[11].txt[6]  = ":dphasage entre u et i";
  pages[11].txt[7]  = "";
  pages[11].txt[8]  = "Pmoy = UIcos";
  pages[11].txt[9]  = "";
  pages[11].txt[10] = "";


  pages[12].titre = "Rseau triphas";
  //                "--------------------"
  //                "---------------------------"
  pages[12].txt[0]  = "u1(t)=U(2)sin(t)";
  pages[12].txt[1]  = "u2(t)=U(2)sin(t-2/3)";
  pages[12].txt[2]  = "u3(t)=U(2)sin(t-4/3)";
  pages[12].txt[3]  = "u1(t)+u2(t)+u3(t) = 0";
  pages[12].txt[4]  = "";
  pages[12].txt[5]  = "tension efficace";
  pages[12].txt[6]  = "triphase: 380V";
  pages[12].txt[7]  = "";
  pages[12].txt[8]  = "dphasage entre tensions:";
  pages[12].txt[9]  = "2/3 ou -2/3";
  pages[12].txt[10] = "";


  pages[13].titre = "mot.async.triphas";
  //                "--------------------"
  //                "---------------------------"
  pages[13].txt[0]  = "inverser sens de rotation";
  pages[13].txt[1]  = "en permutant 2 phases";
  pages[13].txt[2]  = "glissement:";
  pages[13].txt[3]  = "g = (ns-nr)/ns";
  pages[13].txt[4]  = "Puissance lec. absorbe:";
  pages[13].txt[5]  = "Pa = UI(3)cos";
  pages[13].txt[6]  = "Puissance mca. utile:";
  pages[13].txt[7]  = "Pu = T (T:couple en N.m)";
  pages[13].txt[8]  = "";
  pages[13].txt[9]  = "couplage toile/triangle";
  pages[13].txt[10] = "";



  pages[14].titre =  "Protections";
  //                 "--------------------"
  //                 "---------------------------"
  pages[14].txt[0]  = "circuit de puiss/commande";
  pages[14].txt[1]  = "Sectionneur porte fusible";
  pages[14].txt[2]  = "Q1 pas de pouvoir de coup";
  pages[14].txt[3]  = ":pas manoeuvrer en charge";
  pages[14].txt[4]  = "Contacteurs K1,K2,K3";
  pages[14].txt[5]  = "actionns par une bobine";
  pages[14].txt[6]  = "Relais thermique F1";
  pages[14].txt[7]  = "protge actionneur contre";
  pages[14].txt[8]  = "surintensits,rarmement";
  pages[14].txt[9]  = "manuel ncessaire";
  pages[14].txt[10] = "";


  pages[15].titre = "Moteur  CC";
  //                "--------------------"
  //                "---------------------------"
  pages[15].txt[0]  = "n:vit.arbre moteur: t/min";
  pages[15].txt[1]  = ": vit. rot. arbre: rad/s";
  pages[15].txt[2]  = "T:couple lectro-mca: Nm";
  pages[15].txt[3]  = "Ke et Kt : constantes";
  pages[15].txt[4]  = "E: F lectromotr. induite";
  pages[15].txt[5]  = "E = Ke*n";
  pages[15].txt[6]  = "P-m = T = EI";
  pages[15].txt[7]  = "T = EI/ = Kt*I";
  pages[15].txt[8]  = "au dmarrage:";
  pages[15].txt[9]  = "Id = U/r et Td = Kt*Id";
  pages[15].txt[10] = "Pa=UI  Pu=Tu  n=Pu/Pa";

	maxPage = 15;

  // vrifications
  for(i = 0; i <= maxPage;i++)
  {
  	if(strlen(pages[i].titre) > 20)
  	{
  		sprintf(buff, "Le titre %d est trop long (20 car max)", i);
  		DlgMessage("Attention", buff, BT_OK, BT_NONE);
  		exit(0);
  	}

  	for(j = 0; j < 11; j++)
  	{
  		if(strlen(pages[i].txt[j]) > 26)
  		{
  			sprintf(buff, "La ligne %d du %d est trop long (26 car max)", j,i);
  			DlgMessage("Attention", buff, BT_OK, BT_NONE);
  			exit(0);
  		}
  	}
  }



	//PopupMenu();
	while(1)
	{
		ClrScr();

		// affiche le titre (20 car) en gros et centr horizontalement
		FontSetSys(F_8x10);
		DrawStr (80 - strlen(pages[page].titre)*8/2, 0, pages[page].titre, A_NORMAL);

		// affiche le texte
		FontSetSys(F_6x8);
		int y;
		for(y = 0; y < 11; y++)
			DrawStr(2, 12+y*8, pages[page].txt[y], A_NORMAL);


	  short car = ngetchx ();

  	if(car == KEY_ESC)break;

	  if(car == KEY_LEFT)
  	{
  		if(page>0)page--;
	  	else page = maxPage;
  	}

	  if(car == KEY_RIGHT)
  	{
  		if(page<maxPage)page++;
	  	else page = 0;
  	}

	  if(car == KEY_UP)
  	{
  		do
  		{
  			page--;
	  		if(page < 0)page = maxPage;
  		}
  		while(!pages[page].chapter);
	  }
  	if(car == KEY_DOWN)
	  {
  		do
  		{
  			page++;
  			if(page > maxPage)page = 0;
	  	}
  		while(!pages[page].chapter);
	  }

		if(car == KEY_CLEAR)
		{
			ClrScr();
			off();
			break;
		}

		if(car == KEY_ON)
		{
			ClrScr();
			off();
		}

	  if(car == KEY_APPS)
  	{
  		PopupMenu();
	  }
	}

	// sauvegarde le numro de la page en cours
	file = fopen ("txt4s", "w");
	if(file != NULL)
	{
		fputc ((short)page, file);
		fclose (file);
	}
}